-----------------------------------------------------------------------------------------------
-- Client Lua Script for Surls_Group_Builder
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- Surls_Group_Builder Module Definition
-----------------------------------------------------------------------------------------------
local Surls_Group_Builder = {} 
local SGBVersion = "1.3.7e"
local tTimer
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
local kcrSelectedText = ApolloColor.new("UI_BtnTextHoloPressedFlyby")
local kcrNormalText = ApolloColor.new("UI_BtnTextHoloNormal")
local tTemplate = {}
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Surls_Group_Builder:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
	--o.tItems = {} -- keep track of all the list items
	--o.wndSelectedListItem = nil -- keep track of which list item is currently selected

    return o
end

function Surls_Group_Builder:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
		"SGBLib"
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- Surls_Group_Builder OnLoad
-----------------------------------------------------------------------------------------------
function Surls_Group_Builder:OnLoad()
	self.xmlDoc = XmlDoc.CreateFromFile("NewSprite.xml")
	Apollo.LoadSprites("NewSprite.xml", "SGB")
			-- Register Event Handler
	Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
	Apollo.RegisterEventHandler("SGBFire", "StartSGB", self)
	Apollo.RegisterEventHandler("SystemKeyDown", "OnKeyPressed", self)
    --tTimer = ApolloTimer.Create(5, true, "OnTimer", self)
	self.xmlDoc = XmlDoc.CreateFromFile("Surls_Group_Builder.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	self.SGBLib = Apollo.GetPackage("SGBLib").tPackage
end

-----------------------------------------------------------------------------------------------
-- Surls_Group_Builder OnDocLoaded
-----------------------------------------------------------------------------------------------
function Surls_Group_Builder:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "Surls_Group_BuilderForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
		-- item list
		--self.wndItemList = self.wndMain:FindChild("ItemList")
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("sgrpinv", "OnSurls_Group_BuilderOn", self)
		Apollo.RegisterEventHandler("ChatMessage", "OnChatMessage", self)
		Apollo.RegisterEventHandler("Group_Updated","OnGroupUpdate",self)
		--Apollo.RegisterEventHandler("ChatMessage","OnSave",self)
		--Apollo.RegisterEventHandler("ChangeWorld","OnRestore",self)
		invtoggle=false

		--Init of tSettings
		if self.SGBLib.SGBDataIsSet(1) == false then
			self.SGBLib.ResetDatabase()
		end
		tTemplate = self.SGBLib.FetchTD(1)

		self.wndMain:FindChild("KeywordEdit"):SetText(tTemplate.Keyword)
		self.wndMain:FindChild("Promotxt"):SetText(tTemplate.Promotext)
		--self.timer = ApolloTimer.Create(1.0, true, "OnTimer", self)
		
		self.gridTemplate = self.wndMain:FindChild("GridTemplate")
		self.keywordInput = self.wndMain:FindChild("KeywordEdit")
		self.promoInput = self.wndMain:FindChild("Promotxt")
		self.promoBtn = self.wndMain:FindChild("PromoButton")
		self.promoBtnRed = self.wndMain:FindChild("PromoButton1")
		self.btnAddItem = self.wndMain:FindChild("Testbutton")
		self.btnDelItem = self.wndMain:FindChild("Testbutton1")
		self.AboutContent = self.wndMain:FindChild("AboutContent")

		-- Init of Promobtn
		self.promoBtn:Enable(false)
		self.promoBtn:SetTooltip("Post Promo on your selected Channels!")
		-- Init complete Table of Templates
		-- if (type(myEntrys) == "table") then
		-- 	if myEntrys[1] == nil then
		--   			table.insert(myEntrys,1,{self.keyword,self.Promotxt,self.tSettings})
		-- 			--AddInviteTemplate(self.keyword,self.Promotxt)
		-- 			self.nSelectedRow=1
		-- 	end
		-- else
		
		------------------------------ Old Tables -> New --------------------------------

			
		-- end
		--self.wndMain:FindChild("Settingsbtn"):Enable(false)
		self.reset=1
		--if self.tTemplates[1] == nil then 
		--	self.tTemplates = {}
		--	table.insert(self.tTemplates,{self.keyword,"Gruppe fÃ¼r Dungeon gesucht. Wer mÃ¶chte mit."})
		--end
		--self.wndMain:FindChild("KeywordEdit"):SetText(self.keyword)
		-- Do additional Addon initialization here

		self.gridTemplate:SetCurrentRow(1)
		self.nSelectedRow=1
		self.wndMain:FindChild("Background"):SetOpacity(0,0)
		--DoFeedback(GameLib.GetVersionInfo("Surls_Group_Builder"))
		--Apollo.AlertAppWindow("Test")
	end
end

-----------------------------------------------------------------------------------------------
-- Surls_Group_Builder Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/sgrpinv"
function Surls_Group_Builder:OnSurls_Group_BuilderOn()
	self.wndMain:Invoke() -- show the window
	
	-- populate the item list
	self:PopulateItemList()
	self.gridTemplate:SetCurrentRow(1)

end

-- on timer
function Surls_Group_Builder:OnTimer()
	--DoFeedback("Here is the Timer")-- Do your timer-related stuff here.
end

function Surls_Group_Builder:PopulateItemList()
	self.gridTemplate:DeleteAll()
	--if self.SGBLib.GetSGBDataMax() ~= false then
	for i = 1,self.SGBLib.GetSGBDataMax()  do
	
	nRowIndex = self.gridTemplate:AddRow("")
	u=self.SGBLib.GetKeyword(i)
	self.wndMain:FindChild("GridTemplate"):SetCellText(nRowIndex, 1,u)
	
  	--DoFeedback(Text[1])
	--DoFeedback(Text[2])
	--else
		--ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug,Text)
	end
	if self.nSelectedRow ~= nil then
	self.gridTemplate:SetCurrentRow(self.nSelectedRow)

	end
self.keywordInput:SetText(tTemplate.Keyword)
self.promoInput:SetText(tTemplate.Promotext)
end


function Surls_Group_Builder:OnChatMessage(channelCurrent, tMessage)
	local unit = unit or GameLib.GetPlayerUnit()
	
	--DoFeedback(unit:GetName())
	local eChannelType = channelCurrent:GetType()

	if eChannelType == ChatSystemLib.ChatChannel_Guild and invtoggle and GroupLib.AmILeader and self.SGBLib.CanDoInvite() then
		for idx, tSegment in ipairs( tMessage.arMessageSegments ) do
			keywordmatch = tSegment.strText
			--ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug,self.keyword)
			--if keywordmatch==self.keyword then
			if self.CSchk == false then
			if string.find(string.lower(keywordmatch),string.lower(tTemplate.Keyword)) ~= nil then
				--ChatSystemLib.Command('/whisper ' .. tMessage.strSender .. ' ' .. "Autogrp 0.1")
				if tMessage.strSender ~= unit:GetName() then
				GroupLib.Invite(tMessage.strSender,GameLib.GetRealmName(),"You have been invited by Surls Group Builder ver."..SGBVersion)
				end
			end
			else
			if string.find(keywordmatch,tTemplate.Keyword) ~= nil then
				--ChatSystemLib.Command('/whisper ' .. tMessage.strSender .. ' ' .. "Autogrp 0.1")
				if tMessage.strSender ~= unit:GetName() then
				GroupLib.Invite(tMessage.strSender,GameLib.GetRealmName(),"You have been invited by Surls Group Builder ver. "..SGBVersion)
				end
			end

			end
			

		end
			
		
			
	end
end

------- Repair and Check for  Old Tables

--- Handle Auto Raid
function Surls_Group_Builder:OnGroupUpdate()
	StatusGroup = GroupLib.InGroup()
	if StatusGroup and GroupLib.InRaid() == false and invtoggle and GroupLib.AmILeader() and tTemplate.Autoraid then
	-- ToDo Convert to Raid
	GroupLib.ConvertToRaid()
	DoFeedback("Group converted into Raid")
    end
	if true then
	nothing=10
	end
	
end
function Surls_Group_Builder:OnSave(eLevel)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then
        return nil
    end	

	
	local save = self.SGBLib.FetchDatabase()
	
	save.saved = true
	

	return save
	
end

function Surls_Group_Builder:OnRestore(eLevel, tData)
	if tData.saved ~= nil then
		local MyData={}
		MyData = tData
		self.SGBLib.RestoreDatabase(MyData)


	end
	if tData.saved==nil then
		self.SGBLib.ResetDatabase()
	end
end

-----------------------------------------------------------------------------------------------
-- Surls_Group_BuilderForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked



--end

function Surls_Group_Builder:DoPromote()
	local Promotext= self.wndMain:FindChild("Promotxt"):GetText()
	--ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug,Promotext .. " " .. "[Autoinvite active] Invitecode ->" .. self.keyword)
	ChatSystemLib.Command('/g ' .. Promotext .. ' ' .. "[Autoinvite active] Invitecode ->" .. tTemplate.Keyword)
	--tNew={"Hello Guys"}
	--ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug,tNew[1])

	
end

-- when the Cancel button is clicked
function Surls_Group_Builder:OnCancel()
	self.wndMain:Close() -- hide the window
end


function Surls_Group_Builder:OnScanOn( wndHandler, wndControl, eMouseButton )
	self.wndMain:FindChild("ScannerToggle"):SetText("Scanner is On!")
	self.wndMain:FindChild("Animation"):SetSprite("CRB_Anim_PVP_HoldTheLine:spr_HoldTheLine_animRedSpark2")
	invtoggle= true
	
	-- Effekt Ausblenden der Templates
	
	--self.btnAddItem:SetOpacity(0,0.7)
	
	--self.btnDelItem:SetOpacity(0,0.7)
	--self.gridTemplate:SetOpacity(0,0.7)
	--self.wndMain:FindChild("Placeholder"):SetOpacity(100,0.5)

	self.keywordInput:SetTextColor("red")
	self.promoInput:SetTextColor("red")
	self.wndMain:FindChild("Surls_Group_BuilderForm"):SetFocus()
	--self.wndMain:FindChild("KeywordEdit"):AddStyleEx("ReadOnly")
	self.wndMain:FindChild("Promotxt"):AddStyleEx("ReadOnly")
	self.keywordInput:Enable(false)

	-- hiding Templates
	transp=0.8
	self.gridTemplate:Enable(false)
	self.btnAddItem:Enable(false)
	self.btnDelItem:Enable(false)
	self.gridTemplate:SetOpacity(0,transp)
	self.wndMain:FindChild("Background"):SetOpacity(100,6)
	self.btnAddItem:SetOpacity(0,transp)
	self.btnDelItem:SetOpacity(0,transp)
	--self.gridTemplate:Show(false)
	
	self.promoBtnRed:Show(false)
	self.promoBtn:Show(true)
	self.promoBtn:Enable(true)
	self.promoBtn:SetText("Post Promo")
	--self.promoBtn:SetBase("BK3:btnHolo_Green_Small")
	tTemplate.Keyword = self.wndMain:FindChild("KeywordEdit"):GetText()
	tTemplate.Promotext =	self.wndMain:FindChild("Promotxt"):GetText()
	self.wndMain:FindChild("Settingsbtn"):Enable(false)
	

end

function Surls_Group_Builder:OnScanOff( wndHandler, wndControl, eMouseButton )
	self.wndMain:FindChild("ScannerToggle"):SetText("Scanner is Off!")
	self.wndMain:FindChild("Animation"):SetSprite("CRB_Anim_PVP_HoldTheLine:spr_HoldTheLine_animBlueSpark2")
	invtoggle= false
	self.btnAddItem:Show(true)
	self.btnDelItem:Show(true)
	self.gridTemplate:Show(true)
	self.btnAddItem:SetOpacity(100,transp)
	self.btnDelItem:SetOpacity(100,transp)
	self.gridTemplate:SetOpacity(100,transp)
	self.keywordInput:SetTextColor("xkcdAcidGreen")
	self.promoInput:SetTextColor("xkcdAcidGreen")
	self.gridTemplate:Enable(true)
	self.btnAddItem:Enable(true)
	self.btnDelItem:Enable(true)
	self.keywordInput:Enable(true)
	--self.wndMain:FindChild("KeywordEdit"):RemoveStyleEx("ReadOnly")
	self.wndMain:FindChild("Promotxt"):RemoveStyleEx("ReadOnly")
	--self.promoBtnRed:Show(true)
	self.promoBtn:Show(true)
	self.promoBtn:Enable(false)
	self.wndMain:FindChild("Background"):SetOpacity(0,4.5)
	self.promoBtn:Enable(false)
	self.wndMain:FindChild("Settingsbtn"):Enable(true)
	--self.wndMain:FindChild("Placeholder"):SetOpacity(0,0.3)

end








function Surls_Group_Builder:SaveKeyword( wndHandler, wndControl, strText )
 tTemplate.Keyword=strText
 --self.gridTemplate:SetCellText(self.nSelectedRow,1,self.keyword)
if self.nSelectedRow ~= nil then
 self.wndMain:FindChild("GridTemplate"):SetCellText(self.nSelectedRow, 1,  self.wndMain:FindChild("KeywordEdit"):GetText())
 tTemplate.Keyword=strText
 self.SGBLib.UpdateTD(tTemplate,self.nSelectedRow)
end

end

function Surls_Group_Builder:AddGridItem( wndHandler, wndControl, eMouseButton )
	nRowIndex = self.gridTemplate:AddRow("")
	self.wndMain:FindChild("GridTemplate"):SetCellText(nRowIndex, 1,  self.wndMain:FindChild("KeywordEdit"):GetText())
	--DoFeedback("Hello")
	--DoFeedback(self.nSelectedRow)

	if self.nSelectedRow~=nil then
		--lf.nSelectedRow=self.SGBLib.GetSGBDataMax()



	





		--DoFeedback("self.nSelectedRow ist:".. tostring(self.nSelectedRow))
		if self.SGBLib.FetchTD(self.nSelectedRow) then
			tTemplate= self.SGBLib.FetchTD(self.nSelectedRow)
			--DoFeedback("Daten erhalten")
		else
			--DoFeedback("Keine Daten aus Datenbank... Daten unvollständig... lade Default")
			tTemplate={Keyword="Shadowmaster",Promotext="Groupmembers for an incredible Adventure needed. Write the invitecode simply in Guild Channel and u will be invited.",Autoraid=false,Casesensitive=false,Channels={Guild=false}}
			--tTemplate= self.SGBLib.FetchTD(self.nSelectedRow)
		end

		--tTemplate.Keyword = self.wndMain:FindChild("KeywordEdit"):GetText()
		--tTemplate.Promotext = self.wndMain:FindChild("Promotxt"):GetText()
		--self.nSelectedRow=nRowIndex
	--AddInviteTemplate(trgsct,protxt,self.AutoRaidChk,self.CSchk)
	--DoFeedback(table.concat( tTemplate, ", ", 1, table.maxn(tTemplate) ))

	end
	if self.nSelectedRow==nil then
		tTemplate={Keyword="Shadowmaster",Promotext="Groupmembers for an incredible Adventure needed. Write the invitecode simply in Guild Channel and u will be invited.",Autoraid=false,Casesensitive=false,Channels={Guild=false}}
	end


	--self.gridTemplate:SetCellBG(table.maxn(myEntrys),1,"BK3:btnHolo_ListView_CheckPressed")

		self.wndMain:FindChild("KeywordEdit"):SetText(tTemplate.Keyword)
    	self.wndMain:FindChild("Promotxt"):SetText(tTemplate.Promotext)
    	self.AutoRaidChk=tTemplate.Autoraid
    	self.CSchk=tTemplate.Casesensitive
		self.SGBLib.Add2TD(tTemplate)
		self.nSelectedRow=self.SGBLib.GetSGBDataMax()
		self:PopulateItemList()
end

function Surls_Group_Builder:DelGridItem( wndHandler, wndControl, eMouseButton )
	if self.nSelectedRow ~= nil then
	self.gridTemplate:DeleteRow(self.nSelectedRow)

		--if self.SGBLib.SGBDataIsSet(self.nSelectedRow) then
		self.SGBLib.Del2TD(self.nSelectedRow)
 
		--DoFeedback("Sollte gelöscht sein")

	else
		DoFeedback("Check a Template to delete it")
	end
	self.nSelectedRow = 1
	tTemplate=self.SGBLib.FetchTD(1)

	--self.wndMain:FindChild("Grid"):SetCurrentRow(Row to select)
	----- Laden eines Default Templates, if all Templates deleted
	--if self.SGBLib.GetSGBDataMax()==0



	self:PopulateItemList()
end

--function RemoveTableItem(ltable,i)
 --	table.remove(ltable,
--end
function DoFeedback(Text)
	if (type(Text) == "table") then
  	DoFeedback(Text[1])
	DoFeedback(Text[2])
	else
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug,tostring(Text))
	end
--	if Text==false then
--		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug,tostring(Text))
end


function Surls_Group_Builder:OnGridSelectChange(wndControl, wndHandler, iRow, iCol, eMouseButton)
	--DoFeedback("Hello.. Somthing changed")
	-- Alter eintrag speichern
	-- if iRow == nil then
	-- 	iRow = 1
	-- end
	--DoFeedback("iRow: "..tostring(iRow).." nSelectedRow: "..tostring(self.nSelectedRow))
	---------- Save Old Entry

	if self.nSelectedRow == nil then
		self.nSelectedRow = iRow
	end

	if self.nSelectedRow ~= nil then
		--self.nSelectedRow=1
	
		tTemplate.Keyword=self.keywordInput:GetText()
		tTemplate.Promotext=self.promoInput:GetText()
	--if AutoRaidChk == nil then
	if self.AutoRaidChk == nil then
		self.AutoRaidChk=false
	end
	if self.CSchk == nil then
		self.CSchk=false
	end
	tTemplate.Autoraid=self.AutoRaidChk
	tTemplate.Casesensitive=self.CSchk
	tTemplate.Channels={Guild=true}

	self.SGBLib.UpdateTD(tTemplate,self.nSelectedRow)

	--DoFeedback("iRow: "..iRow.." nSelectedRow: "..self.nSelectedRow)

--------------- Load New Entry
	tTemplate=self.SGBLib.FetchTD(iRow)
	self.keywordInput:SetText(tTemplate.Keyword)
	self.promoInput:SetText(tTemplate.Promotext)
	self.AutoRaidChk=tTemplate.Autoraid
	self.CSchk=tTemplate.Casesensitive
	-- Guild Entry is Missing


	--elseif 
	end
	
	
	--local tTemp = {}
self.nSelectedRow=iRow	
	
	--self:PopulateItemList()
end

function Surls_Group_Builder:OnOk( wndHandler, wndControl, eMouseButton )
--self.wndMain:Close() -- hide the window
	ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug,"Es fuscht")
	--t=self.gridTemplate:GetRadioSel()
	--DoFeedback(t)
	--i = 1
	local output={}
	output = self.SGBLib.FetchTD(self.nSelectedRow)
	DoFeedback("Gezogen mit Fetch SgbdData(1):"..output.Keyword)
	DoFeedback("Gezogen mit Fetch SgbdData(2):"..output.Promotext)
	DoFeedback("Gezogen mit Fetch SgbdData(3):"..tostring(output.Autoraid))
	DoFeedback("Gezogen mit Fetch SgbdData(4):"..tostring(output.Casesensitive))
	x = self.SGBLib.GetSGBDataMax()
	DoFeedback("Grösse der Datenbank: "..x)
	--self:PopulateItemList()
end
 
function Surls_Group_Builder:SaveKeyWord( wndHandler, wndControl, strText )
tTemplate.Keyword=strText
self.SGBLib.UpdateTD(tTemplate,self.nSelectedRow)
end

function Surls_Group_Builder:UnhideAboutWindow( wndHandler, wndControl, eMouseButton )
self.wndMain:FindChild("AboutWindow"):Show(true)
--DoFeedback(self.SGBLib.GetAboutTxt())
z=self.SGBLib.GetAboutTxt()
self.AboutContent:SetText(z)
self:SetControlText("Label1","About")
--z=self.SGBLib.DoSomethingWithAWindow()
--ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Debug,z)
end

function Surls_Group_Builder:HideAboutWindow( wndHandler, wndControl, eMouseButton )
elements= {"AboutWindow"}
self:HideControl(elements,false)
self:SetControlText("Label1","Promotional Text")
end

function Surls_Group_Builder:ShowSettings( wndHandler, wndControl, eMouseButton )
-- Hide Template Interface


elemtochange={"Label4","GridTemplate","Testbutton","Testbutton1","Background","ScannerToggle"}

self.SGBLib.HideControl(self.wndMain,elemtochange,false)
self.SGBLib.ToggleShow(self.wndMain,{"PromoButton"})
self.wndMain:FindChild("AdvSettings"):Show(true)

--- Load Settings from Table
-- 	if self.nSelectedRow ~= nil then

-- 	-- Handle Exception of empty Table after Version Update
-- 		if ((myEntrys[self.nSelectedRow])[3])[1] == nil then
-- 			self.AutoRaidChk = false
-- 		else 
-- 			self.AutoRaidChk = ((myEntrys[self.nSelectedRow])[3])[1]
-- 		end
	
	
	
-- 		if ((myEntrys[self.nSelectedRow])[3])[2] == nil then
-- 			self.CSchk = false
-- 		else 
-- 			self.CSchk = ((myEntrys[self.nSelectedRow])[3])[2]
-- 		end	
-- -- Set the Checkboxes
	
	
-- --	DoFeedback(self.AutoRaidChk)
-- 	end


-- 		if self.nSelectedRow == nil then
-- 			if self.AutoRaidChk == nil then
-- 				self.AutoRaidChk = false 
-- 			end	
-- 			if self.CSchk == nil then
-- 				self.CSchk = false
-- 			end
-- 		end


-- New Version .....
	if self.SGBLib.SGBDataIsSet(self.nSelectedRow) then

		self.CSchk=self.SGBLib.GetCasesensitive(self.nSelectedRow)
		self.AutoRaidChk=self.SGBLib.GetAutoraid(self.nSelectedRow)

	
		self.wndMain:FindChild("csbtn"):SetCheck(self.CSchk)
		self.wndMain:FindChild("AutoRaidBtn"):SetCheck(self.AutoRaidChk)
	end

end

function Surls_Group_Builder:SaveSettings( wndHandler, wndControl, eMouseButton )
--elemtochange={"Label4","GridTemplate","Testbutton","Testbutton1","PromoButton","Background","PromoButton1"}
self.SGBLib.HideControl(self.wndMain,elemtochange,true)
self.SGBLib.ToggleShow(self.wndMain,{"PromoButton"})
self.wndMain:FindChild("AdvSettings"):Show(false)
----------------------------------- Get Form Data----------------------------------------------
--DoFeedback("Row:"..self.nSelectedRow)
-- Prepare Table to write 

-- get Checkbox Data
--if wndControl:GetParent():GetCheck("Color")
	tTemplate.Keyword=self.keywordInput:GetText()
	tTemplate.Promotext=self.promoInput:GetText()
	tTemplate.Autoraid=self.AutoRaidChk
	tTemplate.Casesensitive=self.CSchk
	tTemplate.Channels={Guild=true}

	if self.SGBLib.UpdateTD(tTemplate,self.nSelectedRow) then
	--DoFeedback("Settings saved for Row:".. tostring(self.nSelectedRow))
	else
	--DoFeedback("Error: Daten konnten nicht gespeichert")

	--DoFeedback("Aktueller Index: " .. self.nSelectedRow)
	end
self:PopulateItemList()
--DoFeedback(self.AutoRaidChk)
end

function Surls_Group_Builder:OnAutoRaidBtnClick( wndHandler, wndControl, eMouseButton )
	--DoFeedback(wndControl:IsChecked())
	self.AutoRaidChk = wndControl:IsChecked()
	--self.wndMain:FindChild("csbtn"):SetCheck(true)
	
end

function Surls_Group_Builder:OnCSchkClick( wndHandler, wndControl, eMouseButton )
	--DoFeedback(wndControl:IsChecked())
	self.CSchk = wndControl:IsChecked()
	--lf.wndMain:FindChild("csbtn"):SetCheck(true)
	
end

function Surls_Group_Builder:OnGenerateTT( wndHandler, wndControl, eToolTipType, x, y )
x=x+1
if x<=self.SGBLib.GetSGBDataMax() then
	
-- DoFeedback("x="..x)
-- DoFeedback("No. #:"..self.SGBLib.GetSGBDataMax())
	
		

			--if self.SGBLib.GetAutoraid(x) == 
			self.ShowAutoRaidChk = self.SGBLib.GetAutoraid(x)
			self.ShowCSchk = self.SGBLib.GetCasesensitive(x)
	--DoFeedback(self.ShowCSchk)
	
		

	 


	xml = XmlDoc.new()

	xml:StartTooltip(Tooltip.TooltipWidth)
	xml:AddLine("<P Font=\"CRB_Header12\"><A TextColor=\"ChannelAdvice\">Settings:</A> </P>")
	xml:AddLine("<P Font=\"CRB_Interface10\"><A TextColor=\"ChannelAdvice\"><center>~~~~~~~~~~~~~~</center></A></P>")
	xml:AddLine("<P Font=\"CRB_Interface10\"><A TextColor=\"".. self:GetShowColor(self.ShowAutoRaidChk) .."\">AutoRaid</A></P>")
	xml:AddLine("<P Font=\"CRB_Interface10\"><A TextColor=\"".. self:GetShowColor(self.ShowCSchk) .."\">Case sensitive</A></P>")

	
	
	
	

	wndControl:SetTooltipDoc(xml)

end
end

function Surls_Group_Builder:OnMouseMove( wndHandler, wndControl, nLastRelativeMouseX, nLastRelativeMouseY )
--Gen(wndControl)
end

function Surls_Group_Builder:OnCursor( wndHandler, wndControl )
--wndControl:
--DoFeedback(wndControl:GetRow())
end

function Surls_Group_Builder:GetShowColor(bool)
 	if (bool==false) then
	return "red"
	end
	if (bool==true) then
	return "green"
	end
end


function Surls_Group_Builder:Reset( wndHandler, wndControl, eMouseButton )
if self.reset==-1 then
	self.reset=0
end
if self.reset==1 then
self.SGBLib.ResetDatabase()
tTemplate=self.SGBLib.FetchTD(1)
self.promoInput:SetText(tTemplate.Promotext)
self.keywordInput:SetText(tTemplate.Keyword)
self.AutoRaidChk=tTemplate.Autoraid
self.CSchk=tTemplate.Casesensitive
self.nSelectedRow=1
self.gridTemplate:SetCurrentRow(1)


self.wndMain:FindChild("Resetbtn"):SetText("Done! Again?")
self.reset=-1
end
if self.reset == 0  then
self.wndMain:FindChild("Resetbtn"):SetText("Really? O.o")
self.reset=1
end
self:PopulateItemList()
end

function Surls_Group_Builder:SavePromotxt( wndHandler, wndControl, strText )
	 tTemplate.Promotext=strText
 --self.gridTemplate:SetCellText(self.nSelectedRow,1,self.keyword)
if self.nSelectedRow ~= nil then
 --self.wndMain:FindChild("GridTemplate"):SetCellText(self.nSelectedRow, 1,  self.wndMain:FindChild("KeywordEdit"):GetText())
 --tTemplate.Keyword=strText
 self.SGBLib.UpdateTD(tTemplate,self.nSelectedRow)
end
end

-----------------------------------------------------------------------------------------------
-- ItemList Functions
-----------------------------------------------------------------------------------------------
-- populate item list


-- function AddInviteTemplate(vtrgsct,vprotxt,AR,CS)
	
	
-- 	local ttemp = {}
	
-- 	table.insert(myEntrys,{vtrgsct,vprotxt,{ AR,CS,{"Guild"} } } )
-- 	--DoFeedback(t)
	
-- end

-- function UpdateInviteTemplate(vtrgsct,vprotxt,id)
-- 	myEntrys[id] = {vtrgsct,vprotxt}
-- end

---------------------------------
-- Experimental Functions
---------------------------------

function Surls_Group_Builder:StartSGB()
	-- GroupLib.ReadyCheck("Are you ?")
	ChatSystemLib.Command('/sgrpinv ')

	--Print "hello"
end

function Surls_Group_Builder:OnInterfaceMenuListHasLoaded()
	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "Surls Group Builder", {"SGBFire", "", "NewSprite:SGBMenuSprite"})
	
	--self:UpdateInterfaceMenuAlerts();
	
end

function Surls_Group_Builder:HideControl(ControlName, Status)
	for i = 1,table.maxn(ControlName)  do
	self.wndMain:FindChild(ControlName[i]):Show(Status)
	end
end

function Surls_Group_Builder:SetControlText(ControlName,text)
self.wndMain:FindChild(ControlName):SetText(text)
end


--[[
function Surls_Group_Builder:UpdateInterfaceMenuAlerts()
	local bCanDoReadycheck = true
	-- TODO: Check For Leader / Assist
 
	Event_FireGenericEvent("InterfaceMenuList_AlertAddOn", "Surls Group Builder", {bCanDoReadycheck, nil, 0})
end
]]
function Surls_Group_Builder:OnKeyPressed(iKey)
	if iKey == 111 then -- Numpad /
		self:StartSGB();
	end
end


function Surls_Group_Builder:UpdateInterface(tToshow)
		self.wndMain:FindChild("KeywordEdit"):SetText(tToshow.Keyword)
    	self.wndMain:FindChild("Promotxt"):SetText(tToshow.Promotext)
    	self.AutoRaidChk=tToshow.Autoraid
    	self.CSchk=tToshow.Casesensitive
		--self.SGBLib.Add2TD(tTemplate)

		self:PopulateItemList()
end
-----------------------------------------------------------------------------------------------
-- Surls_Group_Builder Instance
-----------------------------------------------------------------------------------------------
local Surls_Group_BuilderInst = Surls_Group_Builder:new()
Surls_Group_BuilderInst:Init()
